

#ifndef SBK_SHIBOKEN_PYTHON_H
#define SBK_SHIBOKEN_PYTHON_H

#include <sbkpython.h>
#include <sbkmodule.h>
#include <sbkconverter.h>
// Bound library includes
// Conversion Includes - Primitive Types

// Conversion Includes - Container Types
#include <array>
#include <list>
#include <map>
#include <utility>
#include <unordered_map>
#include <vector>


// Type indices
enum [[deprecated]] : int {
    SBK_SHIBOKEN_IDX_COUNT                                   = 0,
};

// Type indices
enum : int {
    SBK_Shiboken_IDX_COUNT                                   = 0,
};

// This variable stores all Python types exported by this module.
extern Shiboken::Module::TypeInitStruct *SbkShibokenTypeStructs;

// This variable stores all Python types exported by this module in a backwards compatible way with identical indexing.
[[deprecated]] extern PyTypeObject **SbkShibokenTypes;

// This variable stores the Python module object exported by this module.
extern PyObject *SbkShibokenModuleObject;

// This variable stores all type converters exported by this module.
extern SbkConverter **SbkShibokenTypeConverters;

// Converter indices
enum [[deprecated]] : int {
    SBK_SHIBOKEN_CONVERTERS_IDX_COUNT                        = 2,
};

// Converter indices
enum : int {
    SBK_Shiboken_CONVERTERS_IDX_COUNT                        = 1,
};
// Macros for type check

#endif // SBK_SHIBOKEN_PYTHON_H

